
Redmine - Feature #4155
Automatic spent time logging from commit messages
2009-11-02 16:45 - Marek Siller

Status: Closed Start date: 2009-11-02
Priority: Normal Due date:
Assignee: Jean-Philippe Lang % Done: 100%
Category: Time tracking Estimated time: 0.00 hour
Target version: 1.1.0
Resolution:
Description

We have created a small patch for redmine that enables automatic logging of spent time via commit messages of a versioning
system.

Use case
This patch allows users to log the spent time automatically along with commiting their work to the SCM. It works in a similar way like
referencing or closing issues via commit messages. For example:

Fixed some issue with menu. 

refs #1234 @2h30m

The user does not have to visit the redmine site just to log the spent time any more.

Features
    -  Support for both ways of referencing issues - with keywords (refs, fixes, ...) and with wildcard.
    -  Possibility to turn the feature on or off (default is the original behavior of redmine).
    -  Support for two time formats: as a floating point number (i. e. 2.5) or as a string (i. e. 2h30m or 2h 30m). Time specification must
follow the issue reference (blanks allowed). Examples

refs #1234 @2.5
references #1234 @2h30m
fixes #1234 @2h 30m

    -  Date of logged spent time - date of commit.
    -  Owner of logged spent time - user mapped to the SCM account the commit belongs to.
    -  Uses default (or the first found if no default set) activity for spent time logging.
    -  Comment for logged spent time includes the revision number.

Patch
Tested with Redmine 0.8.5 and the latest development version (both patches included). Tested SCM include Subversion and git.

Patched files
    -  app/models/changeset.rb
    -  app/views/settings/_repositories.rhtml
    -  config/settings.yml (new configuration option: Enable spent time logging)
    -  + language files (two new messages - setting_commit_logtime_enabled and text_commit_logtime) - already translated to German
and Czech

Any feedback or question is welcome!

Sincerelly Yours,
Marek Siller
Karlsruhe Technology Consulting

Related issues:
Related to Redmine - Feature # 1518: Log time via commit messages Closed 2008-06-23
Related to Redmine - Defect # 7630: Spent time in commits not recognized Closed 2011-02-15

Associated revisions
Revision 4470 - 2010-12-05 12:45 - Jean-Philippe Lang

Automatic spent time logging from commit messages (#4155).

History
#1 - 2009-11-02 22:36 - Marek Siller

The biggest difference between this patch / feature and the related feature #1518 is that the syntax in commit message is (in my opinion) a little bit
simpler (no new keywords, just an at-sign) and it allows the developer explicit specification of the spent time for each referenced issue - for instance 

Completed implementation of two new features: refs #1518 @3h 40m #4155 @6h

#2 - 2009-11-02 23:14 - Kamil .

Looks very interesting!

#3 - 2009-11-04 16:46 - Marek Siller
- File LogTime-v2-redmine-0.8.x.patch added
- File LogTime-v2-redmine-devel.patch added

New set of patches for this feature.

Changelog:

    -  Tested with new Redmine release 0.8.6
    -  Bug fix - crash when only minutes were logged as spent time, for example: Fixed bug #123 @30m

#4 - 2009-11-04 18:46 - Jean-Philippe Lang

I think this feature should be added in 0.9.

Another patch for this feature was already submitted in #1518.
Please have a look at its description: http://www.redmine.org/issues/1518#note-14

Here is an exemple:

refs #1
ratio 50
time 1,0
timelogcomment comment for this timelog

2020-09-30 2/15

http://www.redmine.org/issues/1518#note-14


I have to admit that I prefer the shorter syntax:

refs #1234 @2.5
references #1234 @2h30m
fixes #1234 @2h 30m

What do you think? Any suggestion is welcome.

#5 - 2009-11-04 21:05 - Robert Chady

Personally, I prefer the the shorter syntax, not only for its use, but simplicity of the patch.  For those that want something other than the '@' token, it
should be possible to make this a settable option (which token or string to use).

The only other option I see that would be nice is to be able to make the comment get updated in the journal AND the comment if possible -- or
something similar.  I would not want to see a bunch of things getting inserted via comments and not show up in the journal as well from this.

#6 - 2009-11-04 23:17 - Jonas von Andrian

Hi, 
I started the other patch.

I like the shorter syntax, but this patch lacks another feature, which might be nice to have: Assigning ratios via commit messages.
Plus it has no tests.

Apart from that I would prefer this patch, since it's up to date.

#7 - 2009-11-05 12:00 - Marek Siller

Thanks for the feedback!

Robert Chady wrote:

Personally, I prefer the the shorter syntax, not only for its use, but simplicity of the patch.  For those that want something other than the '@' token,
it should be possible to make this a settable option (which token or string to use).

I will add the new setting in next version of this patch. You're right, it'd be nice if redmine users could define their own token / keyword for spent time
logging.

The only other option I see that would be nice is to be able to make the comment get updated in the journal AND the comment if possible -- or
something similar.  I would not want to see a bunch of things getting inserted via comments and not show up in the journal as well from this.

I will investigate how this can be done.

Jonas von Andrian wrote:

Hi, 
I started the other patch.

I like the shorter syntax, but this patch lacks another feature, which might be nice to have: Assigning ratios via commit messages.

Unfortunately, I have no idea, what you mean with assigning ratios via commit messages - could you ellaborate on this subject, please.

Plus it has no tests.

You're right, there are no tests right now, I'm planning on including them in the next version of the patch.

Apart from that I would prefer this patch, since it's up to date.

#8 - 2009-11-06 17:22 - Erik Lindblom

Marek,

I applied the patch, but I'm having issues with it.

Here is the top of the error log:

NoMethodError (undefined method `match' for 0:Fixnum):
  app/models/changeset.rb:144:in `scan_comment_for_issue_ids'
  app/models/changeset.rb:138:in `each'
  app/models/changeset.rb:138:in `scan_comment_for_issue_ids'
  app/models/changeset.rb:70:in `after_create'
  app/models/repository/subversion.rb:59:in `fetch_changesets'
  app/models/repository/subversion.rb:58:in `fetch_changesets'
  app/models/repository/subversion.rb:57:in `reverse_each'
  app/models/repository/subversion.rb:57:in `fetch_changesets'
  app/controllers/repositories_controller.rb:70:in `show'

Any ideas?

I have my "Referencing keywords" set to "*" because I just commit with "(#idnumber)"

#9 - 2009-11-06 17:40 - Marek Siller

Erik Lindblom wrote:

Marek,

I applied the patch, but I'm having issues with it.

Here is the top of the error log:

[...]
Any ideas?

I have my "Referencing keywords" set to "*" because I just commit with "(#idnumber)"

Thanks for letting me know about the bug.

I'll investigate the source of the problem and let you know. Which redmine version do you use and which patch have you applied (version 1 or the
updated version 2)?

#10 - 2009-11-06 17:44 - Erik Lindblom

Version: 0.8.6.devel.3009
Patch v22

#11 - 2009-11-06 18:09 - Marek Siller
- File LogTime-v2.1-redmine-0.8.x.patch added
- File LogTime-v2.1-redmine-devel.patch added

Erik Lindblom wrote:

Version: 0.8.6.devel.3009
Patch v22

I've found the problem and fixed it. New set of patches included. Could you test it and let me know whether it solves your problem, please?

#12 - 2009-11-06 18:22 - Erik Lindblom

Marek Siller wrote:

Erik Lindblom wrote:

Version: 0.8.6.devel.3009
Patch v22

I've found the problem and fixed it. New set of patches included. Could you test it and let me know whether it solves your problem, please?

Tested it and still get an error, here is the log:

ArgumentError (wrong number of arguments (1 for 0)):
  app/models/changeset.rb:164:in `default'
  app/models/changeset.rb:164:in `scan_comment_for_issue_ids'
  app/models/changeset.rb:138:in `each'
  app/models/changeset.rb:138:in `scan_comment_for_issue_ids'
  app/models/changeset.rb:70:in `after_create'
  app/models/repository/subversion.rb:59:in `fetch_changesets'
  app/models/repository/subversion.rb:58:in `fetch_changesets'
  app/models/repository/subversion.rb:57:in `reverse_each'
  app/models/repository/subversion.rb:57:in `fetch_changesets'
  app/controllers/repositories_controller.rb:70:in `show'

#13 - 2009-11-06 18:45 - Marek Siller
- File LogTime-v2.1-redmine-devel.patch added

Sorry, I made a mistake while creating the patch for the devel version. Corrected version in attachement.

#14 - 2009-11-06 19:08 - Erik Lindblom

Great. Thanks! It applies now with no errors, however, none of the time shows up on the tickets.

I've tried (#112) @2 and even the older one, refs #112 @2 and neither of them log time against the ticket.

Is there any more configuration I need besides the option on the administration screen?

Thanks for your time on this!

#15 - 2009-11-09 16:55 - Leonard Brünings

Erik Lindblom wrote:

I've tried (#112) @2 and even the older one, refs #112 @2 and neither of them log time against the ticket.

Try either @2.0 or @2h

#16 - 2009-11-09 17:30 - Erik Lindblom

Just tried this with no luck:

testing (#362) @2h

#17 - 2009-11-11 00:19 - Mischa The Evil

Erik Lindblom wrote:

Just tried this with no luck:
testing (#362) @2h

I think this is due to the used parentheses in you syntax. Probably testing #362 @2h
 works...
#18 - 2009-11-13 20:10 - Erik Lindblom

Mischa The Evil wrote:

Erik Lindblom wrote:

Just tried this with no luck:

[...]

I think this is due to the used parentheses in you syntax. Probably [...] works...

Very odd, I've tried it with that syntax and still nothing. I've also tried on a clean checkout and still doesn't work. There is nothing in the logs as well :/

If anyone has any suggestions, I would love to hear them.

#19 - 2009-11-13 20:28 - Jean-Philippe Lang

Adding a few tests in this patch would lower the noise.

#20 - 2009-11-16 23:30 - Jonas von Andrian

Marek Siller wrote:

Jonas von Andrian wrote:

I like the shorter syntax, but this patch lacks another feature, which might be nice to have: Assigning ratios via commit messages.

Unfortunately, I have no idea, what you mean with assigning ratios via commit messages - could you ellaborate on this subject, please.

It's possible to set a percentage (ratio to 1) how far the ticket has progressed (% Done). I think it would be nice to be able to set that too via the commit
message.

#21 - 2009-12-02 17:29 - Chris Platts

Erik Lindblom wrote:

Mischa The Evil wrote:

Erik Lindblom wrote:

Just tried this with no luck:

[...]

I think this is due to the used parentheses in you syntax. Probably [...] works...
Very odd, I've tried it with that syntax and still nothing. I've also tried on a clean checkout and still doesn't work. There is nothing in the logs as well
:/

If anyone has any suggestions, I would love to hear them.

Hi,

Just for info, I'm seeing this problem behaviour too - patch apparently applies OK, but time entries are not logged.  I'm running the latest SVN version
as of today (0.8.7.devel.3111)

Cheers,
Chris

#22 - 2009-12-07 06:32 - Sachin Khandelwal

Chris Platts wrote:

Erik Lindblom wrote:

Mischa The Evil wrote:

Erik Lindblom wrote:

Just tried this with no luck:

[...]

I think this is due to the used parentheses in you syntax. Probably [...] works...

Very odd, I've tried it with that syntax and still nothing. I've also tried on a clean checkout and still doesn't work. There is nothing in the logs as
well :/

If anyone has any suggestions, I would love to hear them.

Hi,

Just for info, I'm seeing this problem behaviour too - patch apparently applies OK, but time entries are not logged.  I'm running the latest SVN
version as of today (0.8.7.devel.3111)

Cheers,
Chris

Hi,

I'm trying to apply the below mentioned patch to redmine source checkout from "http://redmine.rubyforge.org/svn/tags/0.8.6" using TortoiseSVN.

"LogTime-v2.1-redmine-0.8.x.patch - Patch for version 0.8.x (tested on 0.8.5 and 0.8.6) - corrected version (27.8 KB)  Marek Siller, 2009-11-06 22:39"

Its giving error "The line indicating the new file is expected in line 3". The format of your patch file seems little different from normal. Please help me to
track where I'm going wrong.
Regards,
Sachin

#23 - 2010-02-01 15:26 - Renzo Meister

Hi,
I've installed it and after some trial and errors it works fine. 
But for my use there is one "bug" or better a feature wish. 
I'm working with subprojects so it must be possible to log time for a ticket which is in another project.

I think the problem is in changeset.rb:
...
timeentry = TimeEntry.create(:project => repository.project,
                                      :issue => issue,
...
Here it uses the project of current repository but for me it's better to use the project of the issue. 
Does anybody know how I get the project of my issue and use it?

Regards
Renzo

#24 - 2010-02-18 14:00 - Vladimir Kovacik
- File logtime_redmine_0.9.2.patch added

Since last released patch (LogTime-v2.1-redmine-devel.patch) does not apply correctly on the latest Redmine trunk I have updated the patch and
tested on Redmine 0.9.2 (@3412)

The main issue was related to the following part:

+         if activity == nil
+           activity = TimeEntryActivity.values[0]
+         end

There was also an issue with time getting logged twice when [Referencing keywords] is set to "*". This happens because log_time variable got first time
filled when handling "ref_keywords=*" and second time when handling ref+fix keywords. This is fixed in the attached patch.

#25 - 2010-02-24 14:45 - Tomasz Sawicki

Very nice feature, thank you for contributing.

Another nice thing would be possibility to log the time without referencing particular issue, like:

- doing some cleanups 
@2h30m
so I can log the time spent on something that is not in any issue.
It's just like filling Spent time form without providing issue Id.

#26 - 2010-02-25 01:05 - Tomasz Sawicki

After applying the patch you must include the "spent time" part, otherwise reference to issue will be ignored. Following won't work anymore:

refs #4155

To fix that following line:

target_issues_with_log = match[1].scan(/([\s,;&]*([^@]|#?)\d+)([\s]*@(\d+[.]\d+|(\d+[hm]\s?){1,2}))/)

should be changed to:

target_issues_with_log = match[1].scan(/([\s,;&]*([^@]|#?)\d+)([\s]*@(\d+[.]\d+|(\d+[hm]\s?){1,2}))?/)

(additional question mark near the end of line)

#27 - 2010-03-04 10:13 - Vladimir Kovacik
- File logtime_redmine_0.9.2_v2.2.patch added

Thanks for pointing this issue out. The updated patch is included. Now issue reference is handled correctly even when "Time Spent" is not included
and Referencing keywords are defined (different than *, e.g. refs).

#28 - 2010-04-26 12:49 - Simon Dyson

Is there a version of this patch compatible with Redmine 0.9.3?

#29 - 2010-05-25 01:45 - Katy A
- File logtime_redmine_0.9.2_v2.3.patch added

Here it uses the project of current repository but for me it's better to use the project of the issue. 
Does anybody know how I get the project of my issue and use it?

The updated patch is considering the project of the issue and work with subprojects too.

#30 - 2010-06-22 01:06 - David Parker
+1. prefer this syntax to #1518

#31 - 2010-07-05 16:51 - Dominic Clifton

+1 for this syntax.

#32 - 2010-09-01 19:33 - Paul Widden
- File logtime_redmine_0.9.3_v2.3.patch added

Patch for 0.9.3

#33 - 2010-11-04 15:51 - Dominic Clifton

Does the current patch apply on 1.0.3 or is a new one required?

When will this be integrated into trunk or is there other similar functionality that should be used instead?

#34 - 2010-11-04 16:01 - Dominic Clifton

Current patch applies with:

cd /path/to/redmine
wget http://www.redmine.org/attachments/download/4410/logtime_redmine_0.9.3_v2.3.patch
patch -p 0 -F 3 < logtime_redmine_0.9.3_v2.3.patch

My other questions above still stand.

#35 - 2010-11-09 20:13 - Marek Siller
- File logtime_redmine_1.0.3-v3.patch added

I have created new version of the log spent time patch. The new features are:
    -  corrected regular expressions for spent time logging
    -  function scan_comment_for_issue_ids split into several functions for easier reading and to make it testable
    -  set of tests that check the functionality
    -  logging of spent time creates a new journal entry (activity) associated with the referenced issue (can be switched off in settings)
    -  the activity type (e.g. Development, Design) the spent time is logged on, can be configured in the settings

The patch has been tested both with experimental subversion setup as well as with the test suite, all tests were successful. Tested with stable version
of Redmine (1.0.3) and development version from trunk.

Every feedback regarding the patch and / or feature requests would be greatly appreciated.

Is there any chance, this patch makes it to the main repository of Redmine? What needs to be done in order to get it in the main repository?

#36 - 2010-11-15 18:29 - Jean-Philippe Lang
- Category changed from SCM to Time tracking
- Assignee set to Jean-Philippe Lang
- Target version set to 1.1.0

I'll review your patch as soon as possible.

#37 - 2010-11-15 18:39 - Jean-Philippe Lang
- Tracker changed from Patch to Feature

#38 - 2010-12-05 20:03 - Ivan Cenov

I am translating this to Bulgarian and have a question:

text_time_logged_by_changeset: Applied in changeset {{value}}.

What kind is the value of value ? What information does it comprises of?

Ivan

#39 - 2010-12-06 08:23 - Marek Siller

The value includes the revision number from the commit / changeset - for example r123 for revision 123.

Marek

Ivan Cenov wrote:

I am translating this to Bulgarian and have a question:
[...]

What kind is the value of value ? What information does it comprises of?

Ivan

#40 - 2010-12-11 14:51 - Toshi MARUYAMA
- File fix-scmid-all-number.diff added

r4470 have implemented #6681 feature.
But, if commit id is all numeric (e.g. "0123456789"), auto close text become "Applied in changeset r0123456789".

I attach the patch to fix this problem.
This patch include unit test.

#41 - 2010-12-12 17:01 - Jean-Philippe Lang
- Status changed from New to Closed
- % Done changed from 90 to 100

Implementation was rewritten based on the provided patch.
A few things were changed/removed for consistency (like notes in the issue history, as they are not added when logging time through the UI).

Basically, it works as expected. The syntax is the same as the one you can use to log time through the UI (see
[[RedmineTimeTracking#Accepted-time-formats]]), except that spaces are not allowed to keep parsing simple.

Thanks.

#42 - 2011-02-15 21:24 - гиём шарьм

Is it posisble to update the patch for redmine 1.1?

Thanks.

#43 - 2011-02-15 21:28 - Marek Siller

гиём шарьм wrote:

Is it posisble to update the patch for redmine 1.1?

Thanks.

The patch is already included in redmine version 1.1, as far as I know.

Sincerely,

Marek Siller
KTC - Karlsruhe Technology Consulting GmbH (www.k-tc.de)

#44 - 2011-02-15 21:33 - гиём шарьм

I saw indeed something in administration/settings/repositories : Enable time logging. I tried it but without any result. Do the syntax has changed? Or
does it simply does not work with mercurial?

#45 - 2011-02-15 21:36 - Marek Siller

гиём шарьм wrote:

I saw indeed something in administration/settings/repositories : Enable time logging. I tried it but without any result. Do the syntax has changed?
Or does it simply does not work with mercurial?

It should work with Mercurial as well. Which syntax do you use - as far as I know, Jean-Philippe Lang changed the syntax a little bit - no spaces are
allowed in the spent time entry ... but something like 
Here is my change refs #1234 @1h30m

should work without any problems.

What expression do you use in the commit message?

#46 - 2011-02-15 21:44 - гиём шарьм

I indeed didn't try this syntax.

But I tried 
ref #1234 @2h
and it does not work.

By the way, ref #1234 @XhYYm Apply only Xh and 0 min. Is it normal?
Is there any ratio or timelogcomment command still?

#47 - 2011-02-15 21:56 - Marek Siller

гиём шарьм wrote:

I indeed didn't try this syntax.

But I tried 
ref #1234 @2h
and it does not work.

By the way, ref #1234 @XhYYm Apply only Xh and 0 min. Is it normal?
Is there any ratio or timelogcomment command still?

I have to go through the code to answer you question - I'm not completely familiar with the way the time-logging in redmine 1.1 - we still use 1.0.3 with
the patch I wrote ... but I will try it tommorow and get back to you, how the syntax should exactly work ... and if it does not work work for you in
connection with Mercurial, you should create a new issue / ticket here, so that the developers can track the bug. Even if you create new ticket, I'll be
glad to help you to get it working (just add me to the watch list or send me an email with the link at marek.siller@k-tc.de)

Sincerely,
Marek Siller
KTC - Karlsruhe Technology Consulting GmbH

#48 - 2011-03-03 14:43 - Terence Mill

For this new feature documentation is still missing in wiki redmine user guide
See [[RedmineTimeTracking]] or [[RedmineIssues]]

#49 - 2011-08-24 21:12 - Szymon Nowak

I there any way to apply this patch to Redmine 1.2.1? Is it working with 1.2.1?
#50 - 2011-12-14 09:11 - Daniel Dehennin

Is there a way to specify the activity in the commit messages?

It is defaulted to Developpment but sometimes it could be usefull to change it.

Regards.

#51 - 2012-04-12 08:28 - michele corradin

Hi,
we have moved to version 1.3.2 from an old version patched but it's no more working the syntax "#issue @Xh" in the SVN logging.

I didn't understand from the last post if time tracking is working or not in new versions, can you give me a feedback?

We are really using it a lot
Thanks
michele

#52 - 2012-04-19 11:30 - Jean-Philippe Lang

The syntax "#issue @Xh" should work fine. Make sure that "Enable time logging" option is enabled in Application settings -> Repositories.

Files
LogTime-v1-redmine-0.8.5.patch 27.8 KB 2009-11-02 Marek Siller
LogTime-v1-redmine-devel.patch 30.2 KB 2009-11-02 Marek Siller
LogTime-v2-redmine-0.8.x.patch 27.8 KB 2009-11-04 Marek Siller
LogTime-v2-redmine-devel.patch 30.2 KB 2009-11-04 Marek Siller
LogTime-v2.1-redmine-0.8.x.patch 27.8 KB 2009-11-06 Marek Siller
LogTime-v2.1-redmine-devel.patch 30.2 KB 2009-11-06 Marek Siller
LogTime-v2.1-redmine-devel.patch 30.2 KB 2009-11-06 Marek Siller
logtime_redmine_0.9.2.patch 22.3 KB 2010-02-18 Vladimir Kovacik
logtime_redmine_0.9.2_v2.2.patch 22.3 KB 2010-03-04 Vladimir Kovacik
logtime_redmine_0.9.2_v2.3.patch 22.7 KB 2010-05-24 Katy A
logtime_redmine_0.9.3_v2.3.patch 22.2 KB 2010-09-01 Paul Widden
logtime_redmine_1.0.3-v3.patch 114 KB 2010-11-09 Marek Siller
